package net.sourceforge.ppf.plugin.bf2botplugin;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;
import java.util.HashMap;

import org.jibble.pircbot.Colors;

public class BF2Thread extends Thread {

	HashMap subVals = new HashMap();
	
    boolean msgIrc = true;
	DatagramSocket socket;

    BF2BotPlugin matchPlugin = null;
    HashMap config = null;
    
    public BF2Thread(BF2BotPlugin plugin) {
        matchPlugin = plugin;
        config = matchPlugin.getConfig();
    }
    
	public void run() {
		try {
			receivePackets(BF2BotPlugin.REPORT_CHANNEL, "", "", "");
        } catch(SocketException se) {
            if(se.getMessage().equals("socket closed")) {
                // everything's fine, somebody called destroy() on us
            } else {
                se.printStackTrace();
            }
		} catch(Throwable t) {
			t.printStackTrace();
		} finally {
            if(socket != null) {
                socket.close();
                socket = null;
            }
        }
	}

	public void destroy() {
        if(socket != null) {
            socket.close();
        }
	}
	
	public void setMsgIrc(boolean msgs) {
		msgIrc = msgs;
	}

	private void processLogLine(String channel, String sender, String login,
		String hostname, String line) {
        try {
	    if(line == null || line.length() == 0) {
            return;
        }
        String output = "";
        // locate the marker :
        int marker = line.indexOf(":");
        if(marker > 0) {
            String action = line.substring(0, marker);
            output = (String) config.get(action);
            if(action.startsWith("gameState")){
                String values = line.substring(action.length()+1, line.length()).trim();
                String[] pieces = values.split(",");

                if(action.equals("gameStatePlaying")) {
                    if(config.containsKey("team1Name")) {
                        config.remove("team1Name");
                    }
                    if(config.containsKey("team2Name")) {
                        config.remove("team2Name");
                    }
                    config.put("team1Name", pieces[0]);
                    config.put("team2Name", pieces[1]);

                    output = output.replaceAll("\\$\\{map\\}", pieces[2]);
                    output = output.replaceAll("\\$\\{playerCount\\}", pieces[3]);
                } else if(action.equals("gameStateEndGame")) {
                    output = output.replaceAll("\\$\\{team1\\}", pieces[0]);
                    output = output.replaceAll("\\$\\{team1tickets\\}", pieces[1]);
                    output = output.replaceAll("\\$\\{team2\\}", pieces[2]);
                    output = output.replaceAll("\\$\\{team2tickets\\}", pieces[3]);
                    output = output.replaceAll("\\$\\{team1Colour\\}", (String) config.get("team1Colour"));
                    output = output.replaceAll("\\$\\{team2Colour\\}", (String) config.get("team2Colour"));
                    output = output.replaceAll("\\$\\{map\\}", pieces[4]);                    
                }
            } else if(action.startsWith("ticketStatus")){
                String values = line.substring(action.length()+1, line.length()).trim();
                String[] pieces = values.split(",");

                output = output.replaceAll("\\$\\{team1\\}", pieces[0]);
                output = output.replaceAll("\\$\\{team1tickets\\}", pieces[1]);
                output = output.replaceAll("\\$\\{team2\\}", pieces[2]);
                output = output.replaceAll("\\$\\{team2tickets\\}", pieces[3]);
                output = output.replaceAll("\\$\\{team1Colour\\}", (String) config.get("team1Colour"));
                output = output.replaceAll("\\$\\{team2Colour\\}", (String) config.get("team2Colour"));
                output = output.replaceAll("\\$\\{map\\}", pieces[4]);

            } else if(action.startsWith("player")){
                String values = line.substring(action.length()+1, line.length()).trim();
                String[] pieces = values.split(",");

                if(action.equals("playerConnect")) {
                    output = output.replaceAll("\\$\\{player\\}", pieces[0]);
                } else if(action.equals("playerChangeTeam")) {
                    String teamName = (String) config.get("team"+ pieces[1] +"Name");
                    String teamColour = (String) config.get("team"+ pieces[1] +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);
                    output = output.replaceAll("\\$\\{player\\}", pieces[0]);
                    output = output.replaceAll("\\$\\{playerTeam\\}", teamName);
                } else if(action.equals("playerRevived")) {
                    String teamColour = (String) config.get("team"+ pieces[0] +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);
                    output = output.replaceAll("\\$\\{player\\}", pieces[1]);
                    output = output.replaceAll("\\$\\{playerScore\\}", pieces[2]);
                    output = output.replaceAll("\\$\\{playerKills\\}", pieces[3]);
                    output = output.replaceAll("\\$\\{playerDeaths\\}", pieces[4]);
                    output = output.replaceAll("\\$\\{patient\\}", pieces[5]);
                    output = output.replaceAll("\\$\\{patientScore\\}", pieces[6]);
                    output = output.replaceAll("\\$\\{patientKills\\}", pieces[7]);
                    output = output.replaceAll("\\$\\{patientDeaths\\}", pieces[8]);
                } else if(action.equals("playerKilledSelf")) {
                    String teamColour = (String) config.get("team"+ pieces[1] +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);
                    output = output.replaceAll("\\$\\{player\\}", pieces[0]);
                    output = output.replaceAll("\\$\\{playerScore\\}", pieces[2]);
                    output = output.replaceAll("\\$\\{playerKills\\}", pieces[3]);
                    output = output.replaceAll("\\$\\{playerDeaths\\}", pieces[4]);

                } else if(action.equals("playerTeamkilled")) {
                    String teamColour = (String) config.get("team"+ pieces[0] +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);
                    output = output.replaceAll("\\$\\{player\\}", pieces[1]);
                    output = output.replaceAll("\\$\\{playerScore\\}", pieces[2]);
                    output = output.replaceAll("\\$\\{playerKills\\}", pieces[3]);
                    output = output.replaceAll("\\$\\{playerDeaths\\}", pieces[4]);
                    output = output.replaceAll("\\$\\{victim\\}", pieces[5]);
                    output = output.replaceAll("\\$\\{victimScore\\}", pieces[6]);
                    output = output.replaceAll("\\$\\{victimKills\\}", pieces[7]);
                    output = output.replaceAll("\\$\\{victimDeaths\\}", pieces[8]);
                } else if(action.equals("playerKilled")) {
                    String teamColour = (String) config.get("team"+ pieces[1] +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);

                    String victimColour = (String) config.get("team"+ pieces[6] +"Colour");
                    output = output.replaceAll("\\$\\{victimColour\\}", victimColour);

                    output = output.replaceAll("\\$\\{player\\}", pieces[0]);
                    output = output.replaceAll("\\$\\{playerScore\\}", pieces[2]);
                    output = output.replaceAll("\\$\\{playerKills\\}", pieces[3]);
                    output = output.replaceAll("\\$\\{playerDeaths\\}", pieces[4]);
                    output = output.replaceAll("\\$\\{victim\\}", pieces[5]);                    
                    output = output.replaceAll("\\$\\{victimScore\\}", pieces[7]);
                    output = output.replaceAll("\\$\\{victimKills\\}", pieces[8]);
                    output = output.replaceAll("\\$\\{victimDeaths\\}", pieces[9]);
                    String weapon = pieces[10];
                    int start = weapon.indexOf("_") + 1;
                    String resolvedWeapon = weapon;
                    if(start > 0) {
                        int end = resolvedWeapon.indexOf("_", start);
                        if(end >= 0) {
                            resolvedWeapon = resolvedWeapon.substring(start, end);
                        } else {
                            resolvedWeapon = resolvedWeapon.substring(start);
                        }
                    }
                    resolvedWeapon = matchPlugin.mappings.getProperty(resolvedWeapon.toLowerCase());
                    if(resolvedWeapon != null) {
                        weapon = resolvedWeapon;
                    }
                    output = output.replaceAll("\\$\\{weapon\\}", weapon);
                } else if(action.equals("playerDisconnect")) {
                    String teamColour = (String) config.get("team"+ pieces[1] +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);
                    output = output.replaceAll("\\$\\{player\\}", pieces[0]);
                }
            } else if(action.startsWith("controlPoint")){
                String values = line.substring(action.length()+1, line.length()).trim();
                String[] pieces = values.split(",");

                if(action.equals("controlPointCapture")) {
                    String teamName = (String) config.get("team"+ Integer.parseInt(pieces[0]) +"Name");
                    String teamColour = (String) config.get("team"+ Integer.parseInt(pieces[0]) +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);
                    output = output.replaceAll("\\$\\{team\\}", teamName);
                    output = output.replaceAll("\\$\\{controlPoint\\}", matchPlugin.mappings.getProperty(pieces[1]));
                } else if(action.equals("controlPointNeutralised")) {
                    output = output.replaceAll("\\$\\{controlPoint\\}", matchPlugin.mappings.getProperty(pieces[0]));
                }
                
            } else if(action.startsWith("chat")){
                String values = line.substring(action.length()+1, line.length()).trim();
                String[] pieces = values.split(",");

                if(action.equals("chatServer")) {
                    output = output.replaceAll("\\$\\{msg\\}", pieces[0]);                    
                } else if(action.equals("chatPlayer")) {
                    //text, channel, flags, playerName, playerTeam
                    String teamColour = (String) config.get("team"+ pieces[3] +"Colour");
                    output = output.replaceAll("\\$\\{teamColour\\}", teamColour);
                    String chatMess = "";
                    for(int x=4; x < pieces.length; x++) {
                        if(x > 4) {
                            chatMess += ",";
                        }
                        chatMess += pieces[x];
                    }
                    output = output.replaceAll("\\$\\{msg\\}", chatMess);
                    output = output.replaceAll("\\$\\{channel\\}", pieces[0]);
                    output = output.replaceAll("\\$\\{player\\}", pieces[2]);
                }
                
            } else { // temp fall through
                output = line;    
            }
            
            output = replaceColours(output);
            //templateString = templateString.replaceAll("\\$\\{" + paramName + "\\}", paramValue);
            if(BF2BotPlugin.REPORT_CHANNEL != null) {
                matchPlugin.getBot().sendMessage(channel, output);
            }
        } else { // temp fall through
            if(BF2BotPlugin.REPORT_CHANNEL != null) {
                matchPlugin.getBot().sendMessage(channel, line);
            }
        }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
	}

    protected void receivePackets(String channel, String sender, String login,
        String hostname) throws IOException {

        int serverPort = BF2BotPlugin.SERVER_PORT;
        int packetSize = 1024;

        DatagramPacket packet;
        byte[] data; // For data to be Sent in packets 

        String str;
        socket = new DatagramSocket(serverPort);

        while(true) {
            data = new byte[packetSize];

            // Create packets to receive the message
            packet = new DatagramPacket(data, packetSize);
            // wait indefinitely for arrival of the packet
            socket.receive(packet);

            // print string that was received on server's console
            str = new String(packet.getData(), 0, packet.getLength());

            try {
                processLogLine(channel, sender, login, hostname, str);
            } catch(StringIndexOutOfBoundsException sobex) {
                // eat these
            }
        }
    }

    public String replaceColours(String original) {
        if(original == null) {
            return "";
        }
        String temp = original.replaceAll("\\$BLACK", Colors.BLACK);
        temp = temp.replaceAll("\\$BLUE", Colors.BLUE);
        temp = temp.replaceAll("\\$BOLD", Colors.BOLD);
        temp = temp.replaceAll("\\$BROWN", Colors.BROWN);
        temp = temp.replaceAll("\\$CYAN", Colors.CYAN);
        temp = temp.replaceAll("\\$DARK_BLUE", Colors.DARK_BLUE);
        temp = temp.replaceAll("\\$DARK_GRAY", Colors.DARK_GRAY);
        temp = temp.replaceAll("\\$DARK_GREEN", Colors.DARK_GREEN);
        temp = temp.replaceAll("\\$GREEN", Colors.GREEN);
        temp = temp.replaceAll("\\$LIGHT_GRAY", Colors.LIGHT_GRAY);
        temp = temp.replaceAll("\\$MAGENTA", Colors.MAGENTA);
        temp = temp.replaceAll("\\$NORMAL", Colors.NORMAL);
        temp = temp.replaceAll("\\$OLIVE", Colors.OLIVE);
        temp = temp.replaceAll("\\$PURPLE", Colors.PURPLE);
        temp = temp.replaceAll("\\$RED", Colors.RED);
        temp = temp.replaceAll("\\$REVERSE", Colors.REVERSE);
        temp = temp.replaceAll("\\$TEAL", Colors.TEAL);
        temp = temp.replaceAll("\\$UNDERLINE", Colors.UNDERLINE);
        temp = temp.replaceAll("\\$WHITE", Colors.WHITE);
        temp = temp.replaceAll("\\$YELLOW", Colors.YELLOW);

        return temp;
    }
}
