package net.sourceforge.ppf;

import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;

import org.jibble.pircbot.DccChat;

/**
 * @author DeadEd
 */
// This is a simulated room.  Keeps a group of connections and sends output to all as if
// they were all together.

// TODO: what happens when someone is connected via DCC and changes nick or disconnects
public class DccChatRoom {
    
    private static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
            .getLog(DccChatRoom.class);

    private static final int CHATROOM_TIMEOUT = 120000; 
    private HashMap sessions = new HashMap();
    private PPF bot;
    
    public DccChatRoom(PPF bot) {
        this.bot = bot;
    }
  
    // add a session to the room 
    public void createSession(String sender) {
        if(!sessions.containsKey(sender)) {
            DccChat chatSession = bot.dccSendChatRequest(sender, CHATROOM_TIMEOUT);

            sessions.put(sender, chatSession);
        }
    }
    
    // send the message to everyone in the room
    public void sendMessage(String message) {
        try {
            Iterator users = sessions.values().iterator();
            while(users.hasNext()) {
                DccChat session = (DccChat) users.next();
                session.sendLine(message);
            }
        } catch (IOException e) {
            // skip it - show for debug for now
            if (LOG.isDebugEnabled()) {
                LOG.debug("Error sending message", e);
            }
        }
    }
}
