package net.sourceforge.ppf.util;

import java.util.HashMap;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * @author DeadEd
 */
public class PPFResourceBundle {
    
    private static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
            .getLog(PPFResourceBundle.class);

    private HashMap langs = new HashMap();
    private String bundleName = "";
    
    public PPFResourceBundle(String bundleName) {
        this.bundleName = bundleName;
    }
    
    public boolean addLang(String lang) {
        try {
            Locale locale = new Locale(lang);
            ResourceBundle userResBundle = ResourceBundle.getBundle(bundleName, locale, 
                    Thread.currentThread().getContextClassLoader());

            langs.put(lang, userResBundle);
            return true;
        } catch (MissingResourceException mrex) {
            LOG.error("Error adding language", mrex);        
        }
        
        return false;
    }
    
    public ResourceBundle getBundleForLang(String lang) {
        if(langs.containsKey(lang)) {
            return (ResourceBundle) langs.get(lang);
        }
        
        return null;
    }
    
    public String getString(String lang, String key, String defaultText) {
        String retVal = "";
        try {
            retVal = getBundleForLang(lang).getString(key);
        } catch (MissingResourceException mrex) {
            retVal = defaultText;
        }
        
        return retVal;
    }
}
