package net.sourceforge.ppf.util;

/**
 * @author 2Fast2BCn (allnice.be)
 *         User: Nys Kobe
 *         Date: 14-apr-2005
 *         Time: 21:32:02
 */
public class StringFormatRelation {
    private String html, UTF8, ircCode;

    public StringFormatRelation(String html, String UTF8, String ircCode) {
        this.html = html;
        this.UTF8 = UTF8;
        this.ircCode = ircCode;
    }

    public String getHtml() {
        return html;
    }

    public String getUTF8() {
        return UTF8.toUpperCase();
    }

    public String getIrcCode() {
        return ircCode;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof StringFormatRelation)) return false;

        final StringFormatRelation stringFormatRelation = (StringFormatRelation) o;

        if (!UTF8.equals(stringFormatRelation.UTF8)) return false;
        if (!html.equals(stringFormatRelation.html)) return false;
        if (!ircCode.equals(stringFormatRelation.ircCode)) return false;

        return true;
    }

    public int hashCode() {
        int result;
        result = html.hashCode();
        result = 29 * result + UTF8.hashCode();
        result = 29 * result + ircCode.hashCode();
        return result;
    }
}
